#-----------------------------------------------------------------------------
# Name:        __init__.py
# Purpose:     Zope wrapping to make a rulecore engine run within Zope
#              this way rulecore can fire zope method actions
#
# Author:      Etienne Labuschagne
#
# Created:     2004/23/03
# RCS-ID:      $Id: __init__.py $
# Copyright:   (c) GMS 2004
# Licence:     LGPL
#-----------------------------------------------------------------------------
import Globals
import os
import thread
import time

if os.name == 'nt':
    from rulecore import rulecore
    main = rulecore.setupEnvironment('engine')
else:
    from rulecore.sbin.engine import main
    
ph = Globals.package_home(globals())
configFilePath = os.path.join(ph, 'rulecore.xml')

# we start up one instance of a rulecore server using the config file rulecore.xml in this package's
# folder
# XXX make this path configurable

# we must wait for the Zope main thread to start up before starting up other threads
def startRuleCore(foo):
    # The only reason this is done in this seemingly redundant fashion is to make the method
    # compatable with ThreadedAsync's regitster_loop_callback
    thread.start_new(main.main, (configFilePath,))

try:
    # This will only work from Zope 2.7 and on.
    import Zope.Startup
    print "RuleCore Waiting for Zope to start up"
    def waitForZope():
        while not Zope.Startup.started:
            time.sleep(1)    
        print "Starting RuleCore engine"
        startRuleCore(None)
    thread.start_new_thread(waitForZope, ())
except ImportError:
    # This is pre-Zope 2.7 so we use the ThreadedAsync to call the method for us.
    import ThreadedAsync
    ThreadedAsync.register_loop_callback(startRuleCore)
    print "Done Registering with ThreadedAsync"

